{{
  Provides a real-time software clock
  Singleton object - only 1 created even if used in multiple objects
}}
DAT
hours   byte  0
minutes byte  0
seconds byte  0
days    word  0
time    long  0
  
PUB Init(timePin)
''This only needs to be called once
  phsa := phsb := 0
  frqa := POSX / CLKFREQ * 2                            'One second
  frqb := 1
  ctrb := constant(%01010<<26) + timePin                'Set ctrb to POSEDGE detect
  ctra := constant(%00100<<26) + timePin                'Set NCO mode

PUB UpdateTime | t1
'' Needs to be called fairly frequently - at least 1 per sec though will catch up if called less often
  if time <> (t1 := phsb)
     seconds += (t1 - time)
    if seconds => 60                                    'If it has been a minute
      minutes++
      seconds~
      if minutes => 60                                  'If it has been an hour
        hours++
        minutes~
        if hours => 24                                  'If it has been a day
          days++
          hours~
    time := t1
   
PUB SetTime(day,hour,lmin,sec)
''Set time
''  day - word
''  hour - byte
''  minute - byte
''  seconds - byte
  days := day
  hours := hour
  minutes := lmin
  seconds := sec

PUB GetTime(dayptr,hourptr,minptr,secptr)
''Get current Time
''  day - word
''  hour - byte
''  minute - byte
''  seconds - byte
  word[dayptr] := days
  byte[hourptr] := hours
  byte[minptr] := minutes
  byte[secptr] := seconds